//+------------------------------------------------------------------+
//|                                                    SpeedTest.mq4 |
//|                                      Copyright  2012, komposter |
//|                                          http://www.komposter.me |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, komposter"
#property link      "http://www.komposter.me"
#property show_inputs

extern int Interations	= 10000;
extern int pperiod		= 10;

int start()
{
	int c_up_1 = 0, c_up_2 = 0, c_up_3 = 0;
	int c_dn_1 = 0, c_dn_2 = 0, c_dn_3 = 0;

	Print( "  = ", Bars );

	int t1 = GetTickCount();
	func_original( c_up_1, c_dn_1 );
	int t2 = GetTickCount();

	Print( " : ", (t2 - t1)/1000.0, " , : ", c_up_1, " / ", c_dn_1 );

	func_my( c_up_2, c_dn_2 );
	int t3 = GetTickCount();

	Print( "   (break): ", (t3 - t2)/1000.0, " , : ", c_up_2, " / ", c_dn_2 );

	func_my_2( c_up_3, c_dn_3 );
	int t4 = GetTickCount();

	Print( "   : ", (t4 - t3)/1000.0, " , : ", c_up_3, " / ", c_dn_3 );
}

void func_original( int& count_up, int& count_dn )
{
	for ( int try = 0; try < Interations; try ++ )
	{
		count_up = 0; count_dn = 0;

		//   
		for ( int bar = Bars-pperiod-1; bar > pperiod; bar -- )
		{
			bool up = true, dn = true;

   		//     
   		for ( int i = 1; i <= pperiod; i ++ )
   		{
      		if ( High[bar - i] > High[bar] || High[bar + i] > High[bar]) up = false;
      		if ( Low [bar - i] < Low [bar] || Low [bar + i] < Low [bar]) dn = false;
   		}

			if ( up ) count_up ++;
			if ( dn ) count_dn ++;
		}
	}
}

void func_my( int& count_up, int& count_dn )
{
	for ( int try = 0; try < Interations; try ++ )
	{
		count_up = 0; count_dn = 0;

		//   
		for ( int bar = Bars-pperiod-1; bar > pperiod; bar -- )
		{
			bool up = true, dn = true;

   		//     
   		for ( int i = 1; i <= pperiod; i ++ )
   		{
      		if ( High[bar - i] > High[bar] || High[bar + i] > High[bar]) up = false;
      		if ( Low [bar - i] < Low [bar] || Low [bar + i] < Low [bar]) dn = false;

      		if ( !up && !dn ) break; //    ?
   		}

			if ( up ) count_up ++;
			if ( dn ) count_dn ++;
		}
	}
}

void func_my_2( int& count_up, int& count_dn )
{
	for ( int try = 0; try < Interations; try ++ )
	{
		count_up = 0; count_dn = 0;

		//   
		for ( int bar = Bars-pperiod-1; bar > pperiod; bar -- )
		{
			bool up = true, dn = true;

   		//     
   		for ( int i = 1; i <= pperiod; i ++ )
   		{
      		if ( High[bar - i] > High[bar] || High[bar + i] > High[bar]) { up = false; break; }
   		}

   		//     
   		for ( i = 1; i <= pperiod; i ++ )
   		{
      		if ( Low [bar - i] < Low [bar] || Low [bar + i] < Low [bar]) { dn = false; break; }
   		}

			if ( up ) count_up ++;
			if ( dn ) count_dn ++;
		}
	}
}

